

--/=============================== Sys ================================/--
    scexpTITLESTR = "Sc.Exp (Campaign builder)"
    scexpSFMPQSTR = "ScExp\\ScExpMPQed.exe"
    scexpSCEXPPATH = "ScExp\\"
    scexpCAMPBUILDPATHSTR = scexpSCEXPPATH .. "LastBuiltMap.w3x"
    scexpREGDIR = confregpath
--/========================
    scexpm = wehack.addmenu("ScExp")
    
    scexpcampbuilderm = TogMenuEntry:New(scexpm,"Enable CampaignBuilder",scexpUpdateReg,true)
    wehack.addmenuseparator(scexpm)
    scexpuselastcampm = TogMenuEntry:New(scexpm,"Use \"Recent Document\" as current campaign",scexpUpdateReg,true)
--/========================
    camppath = ""
    submappath = ""
    savemappath = ""
    lastmapname = ""

    function scexpGetCampPath()
        if scexpuselastcampm.checked then
            camppath = grim.getregpair("HKEY_CURRENT_USER\\Software\\Blizzard Entertainment\\WorldEdit\\","Campaign Editor - Recent Document 00")
        else
            camppath = ""
        end
    end

    function scexpCompileFile(filepath)
        compilemap_path(filepath) 
        if mapvalid then
            wehack.messagebox("Compiled to: \n" .. filepath,scexpTITLESTR,false)
        end
    end

    function scexpExportCampaignMapFromTo(campaignPath,submappath,SaveToPath)
        local cmdline = scexpSFMPQSTR .. " -e \"" .. campaignPath .. "\" " .. submappath .. " \"" .. SaveToPath .. "\""
        wehack.runprocess(cmdline)
    end
    
    function scexpImportCampaignMap()
        local cmdline = ""
        if grim.exists(savemappath) then
            cmdline = scexpSFMPQSTR .. " -i \"" .. camppath .. "\" \"" .. savemappath .. "\" \"" .. submappath .. "\""
            wehack.runprocess(cmdline)
        end
    end
    
--/========================
    
    function scexpCompileFileDialog()
        local filepath = wehack.openfiledialog("Warcraft 3 map (*.w3x)|*.w3x|", "w3x", "Source map to compile..", false)
        if filepath == "" then
            return
        end
        scexpCompileFile(filepath)        
    end
    
    function scexpCampaignExport()
        submappath = ""
        savemappath = ""
        scexpGetCampPath()
        if camppath == "" then
            camppath = wehack.openfiledialog("Warcraft 3 Campaign (*.w3n)|*.w3n|", "w3n", "Campaing to export..", false)
        end
        if camppath == "" then
            return 2
        end
        lastmapname = grim.getregpair("HKEY_CURRENT_USER\\Software\\Blizzard Entertainment\\WorldEdit\\","ScExp - LastMapName")
        if lastmapname == 0 or lastmapname == "" or lastmapname == nil then
            lastmapname = ""
        end

        submappath = wehack.inputbox("It is the map in campaign?\nIf so, enter the map name:",scexpTITLESTR,lastmapname)
        if submappath == "" then
            return 2
        end
        
        grim.setregstring("HKEY_CURRENT_USER\\Software\\Blizzard Entertainment\\WorldEdit\\","ScExp - LastMapName",submappath)
        
        savemappath = scexpCAMPBUILDPATHSTR
        --savemappath = wehack.savefiledialog("Warcraft 3 map (*.w3x)|*.w3x|", "w3x", "Save exported map to..")
        if savemappath == "" then
            return 1
        end
        scexpExportCampaignMapFromTo(camppath,submappath,savemappath)
        if not grim.exists(savemappath) then
            wehack.messagebox("Extracting error!\nFile \"" ..savemappath.. "\" not found." ,scexpTITLESTR,false)
            return 1
        end
        return 0
    end
    
    function scexpDoBuildCampaign()
        local result = scexpCampaignExport()
        if result == 0 then
            compilemap_path(savemappath)
            if mapvalid then
                scexpImportCampaignMap()
            end
        elseif result == 2 then
            return
        else
            wehack.messagebox("Campaign export error.",scexpTITLESTR,false)
        end
    end
    
    function scexpMenuBuildCampaign()
        camppath = ""
        scexpDoBuildCampaign()
    end
    
    function scexpBuildCampaign()
        if scexpcampbuilderm.checked then
            scexpDoBuildCampaign()
        end
    end
    
--/=============================== Interface ================================/--
    function scexpAbout()
        wehack.messagebox("ScExp 1.2 - Campaign Builder\n\nAuthor: ScorpioT1000 (@yandex.ru)\n\nSpecial Thanks to:\nShadoW DaemoN (MPQ utility)\nHanabishi (JNGP builds)\nZahanc (bug reports)\n\nPowered by XGM.guru\n2009 - 2018",scexpTITLESTR,false)
    end
    
    scexpcompilefilem = MenuEntry:New(scexpm,"Compile Map..",scexpCompileFileDialog)
    scexpcampexport = MenuEntry:New(scexpm,"Build campaign map..",scexpMenuBuildCampaign)
    wehack.addmenuseparator(scexpm)
    scexpaboutm = MenuEntry:New(scexpm,"About..",scexpAbout)
    
    if grim.getregpair(scexpREGDIR,"Enable CampaignBuilder") == "off" then
        wehack.checkmenuentry(scexpcampbuilderm.menu,scexpcampbuilderm.id,0)
    end
    if grim.getregpair(scexpREGDIR,"Use \"Recent Document\" as current campaign") == "off" then
        wehack.checkmenuentry(scexpuselastcampm.menu,scexpuselastcampm.id,0)
    end
